;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Export:
	;Quits the app, but first exports the top stack value as a string in Ans.
	;Okay, first we need to do some memory checks
	bit flagInputActive,(iy+asm_Flag1)
	jp nz,Interface_Input
	ld a,(rpnEntryCount)
	or a
	jp z,App_Exit
	ld hl,(rpnNextEntry)
	dec hl
	ld d,(hl)
	dec hl
	ld e,(hl)
	ex de,hl
	push hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	res 7,b
	ld hl,15
	add hl,bc
	ex de,hl
	;DE is the number of bytes that we need
	ld hl,(mathAreaEnd)
	ld bc,(mathAreaStart)
	or a
	sbc hl,bc
	;HL is the length of our string
	or a
	sbc hl,de
	jp c,MemoryError
	sbc hl,de
	jp c,MemoryError
	sbc hl,de
	jp c,MemoryError		;Throw an error instead of continuing to quit
	pop hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	res 7,b
	inc bc
	inc bc
	dec hl
	ld de,(mathAreaStart)
	push bc
	ldir		;copied...now at HL we want to delete some bytes, don't we?
	pop bc
	push de
	ld hl,(mathAreaEnd)
	ld de,(mathAreaStart)
	or a
	sbc hl,de
	inc hl
	;HL is the actual length...subtract this stuff.
	or a
	sbc hl,bc
	;HL is the excess length
	ex de,hl
	pop hl
	push bc
	B_CALL DelMem
	B_CALL AnsName
	rst rFINDSYM
	jr c,Export_SkipAnsDel
	B_CALL DelVarArc
Export_SkipAnsDel:
	ld hl,workingspace
	rst 20h
	B_CALL FindSym
	inc de
	inc de
	ld (mathAreaStart),de
	pop bc
	ld hl,(mathAreaStart)
	dec hl
	ld (hl),b
	dec hl
	ld (hl),c
	;Now we are free to create a temporary string and expand the number at
	;(mathAreaStart) into it.
	inc hl
	inc hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	ld a,10000000b
	and b
	rlca
	;A is 1 or zero depending on whether the number is negative
	ld e,a
	res 7,b
	inc hl
	ld a,(hl)
	ld hl,0
	ld d,0
	and 11110000b
	or a
	jr nz,Export_NoExtraDigit
	dec de
Export_NoExtraDigit:
	sla c
	rl b
	add hl,bc
	add hl,de
	;HL is the length of the string to create
	push hl
	ld hl,Export_Ans
	ld de,OP1
	ld bc,4
	ldir
	pop hl
	B_CALL CreateStrng
	inc de
	inc de
	push de
	ld hl,workingspace
	rst 20h
	B_CALL FindSym
	inc de
	inc de
	ex de,hl
	pop de
	ld c,(hl)
	inc hl
	ld b,(hl)
	ld a,b
	res 7,b
	sla c
	rl b
	bit 7,a
	jr z,Export_SkipNegative
	ld a,tChs
	ld (de),a
	inc de
Export_SkipNegative:
	inc hl
	ld a,(hl)
	and 11110000b
	jr nz,Export_Loop
	dec bc
Export_Loop:
	ld a,(hl)
	bit 0,c
	jr z,Export_High
	and 00001111b
	add a,t0
	ld (de),a
	inc de
	inc hl
	dec bc
	ld a,b
	or c
	jr nz,Export_Loop
	jr Export_Exit
Export_High:
	and 11110000b
	srl a
	srl a
	srl a
	srl a
	add a,t0
	ld (de),a
	inc de
	dec bc
	ld a,b
	or c
	jr nz,Export_Loop
Export_Exit:
	jp App_Exit
Export_Ans:
	DB StrngObj, tAns,0,0
